
# My::Combination 用例：破解SSH-KEY 的密码

# gem install sshkey
require "sshkey"
require "my/combination"

# 由于性能问题，最好只用于7位数以下、只包含数字和字母的密码
# chars = [*'A'..'Z', *'a'..'z', *'0'..'9']
chars = [*'0'..'9']

# 密码位数
digit = 6

# 生成随机密码
password = digit.times.map{ chars.sample }.join

filename = "/tmp/my_ssh_key_brute_forc"

# 生成带密码的 ssh key
system "ssh-keygen -N #{password} -f #{filename}"

key = File.read(filename)

# TODO 可以利用 start 和 stop 分发到多个进程中执行
comb = My::Combination.new([chars]*digit)
start = Time.now

puts "Start at #{start}"

loop do
  begin
    pw = comb.values.join
    SSHKey.new(key, passphrase: pw)
    puts "Index is #{comb.index}, Password is #{pw}, Used #{Time.now - start}"
    break
  rescue OpenSSL::PKey::DSAError
  end
  comb.succ!
end
